//ljw 2016-12-09 added varibles to keep up with where we are touch-event-wise to enable scrolling

var my_touchstart = false;
var my_touchend = false;
var my_touchmove = false;

// *****************************************************************
// Activate touchstart event for Bootstrap mobile devices
// L Jack Wilson copied from inde 15.5 r9 2016-12-08
// File: csharp\RD3\Objects\ValueListItem.js
// Function: ValueListItem.prototype.RealizeCombo
// Only difference is we add obj.ontouchstart
// This allows us to be able to select a value item in a combo box with touch
// 
// *****************************************************************

// ***************************************************************
// Crea gli option di una combo
// ****************************************************************
ValueListItem.prototype.RealizeCombo= function(tbody, comboid, idx, vs, sel, multisel, hl, lke, hasImg)
{
  // Creo gli oggetti visuali
  var obj = document.createElement("TR");
  obj.className = "combo-option";
  if (!RD3_Glb.IsMobile())
  {
	  obj.onmouseover = new Function("ev","return RD3_DesktopManager.CallEventHandler('"+comboid+"', 'OnOptionMouseOver', ev,"+idx+")");
	  obj.onmouseout = new Function("ev","return RD3_DesktopManager.CallEventHandler('"+comboid+"', 'OnOptionMouseOut', ev,"+idx+")");
	  obj.onclick = new Function("ev","return RD3_DesktopManager.CallEventHandler('"+comboid+"', 'OnOptionClick', ev,"+idx+")");
	  //ljw 2016-12-08 added for touch devices
	  obj.ontouchstart = new Function("ev","return RD3_DesktopManager.CallEventHandler('"+comboid+"', 'OnTouchStart', ev,"+idx+")");
	  obj.ontouchmove = new Function("ev","return RD3_DesktopManager.CallEventHandler('"+comboid+"', 'OnTouchMove', ev,"+idx+")");
	  obj.ontouchend = new Function("ev","return RD3_DesktopManager.CallEventHandler('"+comboid+"', 'OnTouchEnd', ev,"+idx+")");
	}
  obj.id = comboid + ":"+idx;
  tbody.appendChild(obj);
  //
  this.TR = obj;
  //
  var cols = this.HtmlNames.split('|');
  var ncols = cols.length;
  var thead = tbody.previousSibling;
  var multicol = (thead && thead.style.display == "");
  //
  // Se l'item ha un suo VisualStyle uso quello
  if (this.VisualStyle)
    vs = this.VisualStyle;
  //
  // Se la lista e' in formato tabellare sbircio quante colonne ha l'intestazione
  if (thead && thead.style.display != "none")
    ncols = thead.firstChild.childNodes.length - 2;
  //
  // Nella prima colonna il check se c'e'
  var td0 = document.createElement("TD");
  obj.appendChild(td0);
  if (multisel && this.Value != "" && this.Enabled && (!lke || (this.Value!="LKEPREC" && this.Value!="LKENULL" && this.Value!="LKEMORE" && this.Value!="LKEPLUS")))
  {
    var optsel = document.createElement("input");
    optsel.type = "checkbox";
    optsel.className = "combo-option-check";
    //
    td0.appendChild(optsel);
    //
    // A causa di un baco di IE non si puo' checkare prima di avere un parent
    // NON spostare prima dell'appendChild
    optsel.checked = sel;
    //
    // Imposto la larghezza della colonna
    td0.style.paddingLeft = "2px";
    td0.style.paddingRight = "4px";
    td0.style.width = "12px";
    td0.style.cursor = "default";
  }
  else
    td0.style.padding = "0px";
  //
  // Nella seconda colonna l'immagine se c'e'
  var td1 = document.createElement("TD");
  obj.appendChild(td1);
  var optimg = null;
  if (this.Image != "")
  {
    optimg = document.createElement("IMG");
    optimg.className = "combo-option-img" + (multicol && hasImg ? " combo-td-multi" : "");
    optimg.src = RD3_Glb.GetImgSrc("images/"+this.Image)
    td1.appendChild(optimg);
    //
    // Voglio sapere quando arrivano le immagini... cosi' la combo puo' essere dimensionata correttamente
    if (RD3_Glb.IsIE(10, false))
      optimg.onreadystatechange = new Function("ev","return RD3_DesktopManager.CallEventHandler('"+comboid+"', 'OnComboImageLoaded', ev)");
    else
      optimg.onload = new Function("ev","return RD3_DesktopManager.CallEventHandler('"+comboid+"', 'OnComboImageLoaded', ev)");
    //
    // Imposto la larghezza della colonna
    td1.style.width = RD3_ClientParams.ComboImageSize + "px";
    //
    if (RD3_Glb.IsMobile())
      td1.style.paddingLeft = "4px";
  }
  else
    td1.style.padding = "0px";
  //
  for (var i = 0; i < ncols; i++)
  {
    var tdn = document.createElement("TD");
    if (multicol)
      tdn.className = "combo-td-multi";
    obj.appendChild(tdn);
    var optcnt = document.createElement("SPAN");
    optcnt.className = "combo-option-name";
    optcnt.innerHTML = RD3_Glb.HandleIconString(cols[i]);
    tdn.appendChild(optcnt);
    //
    // Applico lo stile al nome dell'item
    var s = optcnt.style;
    var fn = vs.GetFont(1); // VISFNT_VALUE
    var fnt = fn.split(",");
    s.fontFamily = fnt[0];
    s.fontWeight=(fnt[1].indexOf("B")>-1)?"bold":"normal";
    s.fontStyle=(fnt[1].indexOf("I")>-1)?"italic":"normal";
    s.textDecoration=(fnt[1].indexOf("U")>-1)?"underline":"none";
    s.textDecoration=(fnt[1].indexOf("S")>-1)?"line-through":"none";
    s.fontSize = fnt[2]+"pt";
    if (this.Enabled)
    	s.color = vs.GetColor(1); // VISCLR_FOREVALUE=1
    //
    if (!sel && this.Enabled)
      optcnt.style.cursor = "pointer";
    if (i==0 && this.Image != "" && RD3_Glb.IsMobile())
      s.paddingLeft = RD3_ClientParams.ComboImageSize + 10 + "px";
    //
    // Se l'item non ha tutte le colonne (<empty>, LKEPREC, LKENULL, LKEMORE)
    // spalmo la colonna su tutta la riga
    if (i == 0 && ncols > cols.length)
    {
      tdn.colSpan = ncols;
      break;
    }
  }
  //
  // Se e' selezionato applico il colore di sfondo
  if (sel)
  {
    // Non metto lo sfondo "azzurro" se l'item e' vuoto
  	if (!multisel || this.Value!="")
  	{
	    obj.style.backgroundColor = vs.GetColor(9); // VISCLR_HILIGHT
	    RD3_Glb.AddClass(obj, "combo-option-selected");
	  }
  }
  else
  {
    // Non e' selezionato
    obj.style.backgroundColor = vs.GetColor(5); // VISCLR_BACKVALUE
    RD3_Glb.RemoveClass(obj, "combo-option-selected");
    //
    // Se e' abilitato
    if (this.Enabled)
    {
      // Aggiungo il cursor
      obj.style.cursor = "pointer";
      if (optimg) optimg.style.cursor = "pointer";
    }
    else
    {
      RD3_Glb.AddClass(obj, "combo-option-disabled");
    }
  }
  //
  if (hl && multisel)
    RD3_Glb.AddClass(obj, "combo-option-hiligth");
}

// *****************************************************************
// Activate touchstart event for Bootstrap mobile devices
// L Jack Wilson copied from inde 15.5 r9 2016-12-08
// File: csharp\RD3\Objects\IDCombo.js
// Function: IDCombo.prototype.OnTouchStart
// Copied code from IDCombo.prototype.OnOptionClick
// This allows us to be able to select a value item in a combo box with touch
// To-Do: need to integrate OnOptionCheck in here
// 
// *****************************************************************
// ********************************************************************************
// Eventi di tocco sul combo popup
// ********************************************************************************
IDCombo.prototype.OnTouchStart = function(ev, idxs)
{
	//console.log("OnTouchStart!");
	my_touchstart = true;
	my_touchmove = false;
	my_touchend = false;
  // Cerco l'opzione selezionata
  var sel = this.OptionList.ItemList[parseInt(idxs)];
  //
  // Se e' abilitata
  if (sel && sel.Enabled)
  {
    // Recupero l'oggetto che e' stato cliccato
    var checkObj = (window.event)?window.event.srcElement:ev.target;
    //
    // Se ho cliccato su un TD
    if (checkObj.tagName == "TD")
    {
      // Passo la palla all'eventuale check in esso contenuto
      checkObj = checkObj.childNodes[0];
      //
      // Cambio lo stato del check
      if (checkObj)
        checkObj.checked = !checkObj.checked;
    }
    //
    // Se e' stato cliccato un check di opzione
    if (checkObj && checkObj.className == "combo-option-check")
    {
      // Rido' il fuoco all'input per poter continuare a scrivere
      if (!RD3_Glb.IsTouch() && this.Writable)
      {
        if (this.ComboPopupInput)
          this.ComboPopupInput.focus();
        else
          this.ComboInput.focus();
      }
      //
      this.OnOptionCheck(sel, checkObj.checked);
    }
    else
    {
      // la seleziono e chiudo il popup
      this.SelItems = new Array();
      this.SelItems.push(sel);      
      this.Close();
    }
  }
} 

IDCombo.prototype.OnTouchMove = function(ev,idxs)
{ 
  //console.log("OnTouchMove!");
  my_touchstart = true;
	my_touchmove = true;
	my_touchend = false;
}

IDCombo.prototype.OnTouchEnd = function(ev, idxs)
{ 
  //console.log("OnTouchEnd!");
  my_touchstart = false;
	my_touchmove = false;
	my_touchend = true;
}

// *****************************************************************
// Don't close if we are scrolling on touch devices
// L Jack Wilson copied from inde 15.5 r9 2016-12-09
// File: csharp\RD3\Objects\IDCombo.js
// Function: IDCombo.prototype.Close
// Copied code from IDCombo.prototype.Close
// ***************************************************

// Chiude la combo (il popup)
// ***************************************************
IDCombo.prototype.Close = function(undo)
{
	//ljw 2016-12-09 added this check to prevent close of we can scroll
	if (RD3_Glb.IsTouch() && this.Writable && !my_touchend) {
		//console.log("IDCombo.prototype.Close: bypassing!");
		return;
	}
  // Se la combo era aperta
  
  if (this.ComboPopup && this.ComboPopup.style.display=="")
  {
    var fx = new GFX("combo", false, this, RD3_Glb.IsFirefox(3));
    RD3_GFXManager.AddEffect(fx);
  }
  //
  // Se il dummy input era visibile
  if (this.ComboPopupInput && !RD3_Glb.IsMobile())
    this.ComboPopupInput.style.display = "none";
  //
  // Se il timer e' in esecuzione, lo fermo
  if (this.ComboPopupTimer!=0)
  {
    window.clearInterval(this.ComboPopupTimer);
    this.ComboPopupTimer = 0;
  }
  //
  // Confermo il valore all'Owner
  if (undo)
  {
    // Cerco se nella lista c'e', per caso, il valore originale della combo
    if (this.OptionList && !this.ListOwner)
    {
      var list = this.OptionList.ItemList;
      var last = list[list.length-1];
      if (last && last.Value=="LKEPREC")
        this.OriginalText = (this.ShowValue ? last.Value : last.Name);
    }
    //
    // Ripristino il valore presente al momento dell'apertura
    // Se ho un testo originale uso quello, altrimenti uso il testo vuoto
    // Se sono MultiSel e chiusa voglio acquisire comunque il valore
    if (!this.MultiSel || !this.IsOpen)
      this.SetText(this.OriginalText!=undefined ? this.OriginalText : "", this.ShowValue);
  }
  else
  {
    // Se ho un item selezionato lo valido
    if (this.SelItems.length>0)
    {
      // Aggiorno il valore dell'input
      this.SetComboValue(this.GetComboFinalName(this.ShowValue));
      //
      // Memorizzo il testo attualmente presente nell'input (per gestire bene il KeyUp)
      this.PreviousInputText = this.ComboInput.value;
      //
      // Memorizzo il testo originale presente nell'input
      this.OriginalText = this.ComboInput.value;
    }
    //
    // Se non ho un item selezionato
    if (this.SelItems.length==0)
    {
      // Non c'e' un item selezionato: se c'e' del testo dentro all'input vedo se la combo permette testo libero.
      // Se non lo permette, ripristino il valore originale (se c'e')
      if (this.ComboInput.value!="" && !this.AllowFreeText)
        this.SetText(this.OriginalText!=undefined ? this.OriginalText : "", this.ShowValue);
      //
      // Se non c'e' un valore ma la combo non ammette il valore opzionale, ripristino il valore originale
      if (this.ComboInput.value=="" && !this.IsOptional)
        this.SetText(this.OriginalText!=undefined ? this.OriginalText : "", this.ShowValue);
    }
  }
  //
  // Aggiorno l'immagine
  this.UpdateImage();
  //
  // Do' il fuoco all'input, se non sono al tocco
  if (!RD3_Glb.IsTouch() && this.Writable)
    this.ComboInput.focus();
  //
  // Ora la combo non e' piu' aperta
  RD3_DDManager.OpenCombo = null;
  this.IsOpen = false;
  //
  // Se il primo item selezionato ha uno stile lo applico
  // Devo aggiornare il VS di PValue siccome e' lui che comanda
  if (this.SelItems.length>0 && this.SelItems[0].VisualStyle && this.Owner.PValue)
  {
    this.Owner.PValue.SetVisualStyle(this.SelItems[0].VisualStyle);
    this.Owner.PValue.UpdateScreen();
  }
  //
  // Informo l'owner che e' cambiato il valore
  if (this.Owner.OnComboChange)
  {
    // Se non sono list-owner e chiudo la combo, devo comunque informare il server di quel che ho fatto/selezionato
    if (!this.ListOwner)
      this.Owner.OnComboChange(true, true);
    else
      this.Owner.OnComboChange(!undo);
  }
  //
  if (this.Owner.OnMultipleComboChange)
  {
    this.Owner.OnMultipleComboChange(this);
  }
}
